new;
library optmum,pgraph;

rndseed 1234565;

#include gev.src;
#include mlegev.src;
#include copula.src;
#include gumbel.src;

data = loadd("cac-dj");

CAC40 = data[.,2];        /* CAC 40 */
DJ = data[.,3];           /* Dow Jones */

y = packr(CAC40~DJ);
data = ln(y);
r = data - lag1(data);
Nobs = rows(r);

varphi = 22;       /* one month of trading */

block_CAC40 = reshape(r[.,1],Nobs/varphi,varphi)';
block_DJ = reshape(r[.,2],Nobs/varphi,varphi)';

min_CAC40 = -minc(block_CAC40);
min_DJ = -minc(block_DJ);
max_CAC40 = maxc(block_CAC40);
max_CAC40 = maxc(block_DJ);

/*
**> Modelisation of the dependence of Min/Min 
**
*/

x1 = min_CAC40; 
x2 = min_DJ;

{mu,sigma,xi} = mleGEV(x1,0);
theta1 = mu|sigma|xi;
u1 = cdfGEV(x1,mu,sigma,xi);
{mu,sigma,xi} = mleGEV(x2,0);
theta2 = mu|sigma|xi;
u2 = cdfGEV(x2,mu,sigma,xi);
{alpha,stderr,logl} = mleGumbelCopula(u1,u2,1.25);

x1 = 0.10;
x2 = 0.10;
u1 = cdfGEV(x1,theta1[1],theta1[2],theta1[3]);
u2 = cdfGEV(x2,theta2[1],theta2[2],theta2[3]);

C = cdfGumbelCopula(u1,u2,alpha);
tau1 = 1./(1 - u1 - u2 + C)*varphi/265; 

C = u1.*u2;
tau2 = 1./(1 - u1 - u2 + C)*varphi/265; 

e = u1 .> u2;
C = e .* u2 + (1-e) .* u1;
tau3 = 1./(1 - u1 - u2 + C)*varphi/265; 

cls;

print tau1;
print tau2;
print tau3;